## bowtie2 2.3.4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8) 

cmake_policy(SET CMP0048 NEW)
cmake_policy(SET CMP0005 NEW)

project(bowtie2 LANGUAGES CXX VERSION "2.3.4.2")

enable_testing()

include(CTest)
include(ProcessorCount)
include(CheckSymbolExists)

ProcessorCount(NUM_CORES)

option(BOWTIE_MM "enable bowtie2 memory mapping" ON)
option(BOWITE_SHARED_MM "enable shared memory mapping" ON)

set(CMAKE_CXX_STANDARD 98)
set(NO_TBB ${NO_TBB})
set(NO_SPINLOCK, ${NO_SPINLOCK})
set(WITH_THREAD_PROFILING ${WITH_THREAD_PROFILING})
set(POPCNT_CAPABILITY ${POPCNT_CAPABILITY})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64 -g3 -Wall -msse2")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -funroll-loops")
set(INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE PATH "Installation directory for executables")

set(CMAKE_EXPORT_COMPILE_COMMANDS on)

if (MINGW)
    option(BOWTIE_MM "Memory mapped files not supported on Windows" OFF)
    option(BOWTIE_SHARED_MEM "Shared memory not supported on Windows" OFF)
endif(MINGW)

if (APPLE)
    set(CMAKE_XCODE_ATTRIBUTE_DEBUG_INFORMATION_FORMAT "dwarf-with-dsym")
endif(APPLE)

set(BOWTIE2_BIN_LIST
    bowtie2-build-s
    bowtie2-build-l
    bowtie2-align-s
    bowtie2-align-l
    bowtie2-inspect-s
    bowtie2-inspect-l
    )

set(SHARED_CPPS
    ccnt_lut.cpp
    ref_read.cpp
    alphabet.cpp
    shmem.cpp
    edit.cpp
    bt2_idx.cpp
    bt2_io.cpp
    bt2_util.cpp
    reference.cpp
    ds.cpp
    multikey_qsort.cpp
    limit.cpp
    random_source.cpp
    )

set(SEARCH_CPPS
    qual.cpp pat.cpp sam.cpp
    read_qseq.cpp aligner_seed_policy.cpp 
    aligner_seed.cpp 
    aligner_seed2.cpp 
    aligner_sw.cpp 
    aligner_sw_driver.cpp aligner_cache.cpp 
    aligner_result.cpp ref_coord.cpp mask.cpp 
    pe.cpp aln_sink.cpp dp_framer.cpp 
    scoring.cpp presets.cpp unique.cpp 
    simple_func.cpp 
    random_util.cpp 
    aligner_bt.cpp sse_util.cpp 
    aligner_swsse.cpp outq.cpp 
    aligner_swsse_loc_i16.cpp 
    aligner_swsse_ee_i16.cpp 
    aligner_swsse_loc_u8.cpp 
    aligner_swsse_ee_u8.cpp 
    aligner_driver.cpp
    bowtie_main.cpp
    bt2_search.cpp
    )

set(BUILD_CPPS
    bt2_build.cpp
    diff_sample.cpp
    bowtie_build_main.cpp)

set(INSPECT_CPPS
    bt2_inspect.cpp 
    )

string(TIMESTAMP BUILD_DATE)
execute_process(COMMAND ${CMAKE_CXX_COMPILER} -v OUTPUT_VARIABLE COMPILER_VERSION)

add_definitions(
    -DBOWTIE2
    -DBUILD_HOST="${CMAKE_HOST_SYSTEM}"
    -DBUILD_TIME="${BUILD_DATE}"
    -DCOMPILER_VERSION="${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_VERSION}"
    -DBOWTIE2_VERSION="${PROJECT_VERSION}"
    -D_LARGEFILE_SOURCE
    -D_FILE_OFFSET_BITS=64
    -D_GNU_SOURCE
    )

if (WITH_AFFINITY)
    add_definitions(-DWITH_AFFINITY=1)
endif()

if (NO_SPINLOCK)
    add_definitions(-DNO_SPINLOCK)
endif()

if (POPCNT_CAPABILITY)
    add_definitions(-DPOPCNT_CAPABILITY)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -I third_party")
endif()

if (WITH_THREAD_PROFILING)
    add_definitions(-DPER_THREAD_TIMING=1)
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Release")
    add_definitions(-DNDEBUG)
endif()

find_package(Threads REQUIRED)
find_package(ZLIB REQUIRED)
find_path(TBB_INCLUDE_PATH tbb)
find_library(TBB_LIBRARY_PATH tbb)
find_library(TBB_MALLOC_LIBRARY_PATH tbbmalloc)

if (ZLIB_FOUND)
    link_libraries(${ZLIB_LIBRARIES})
    include_directories(${ZLIB_INCLUDE_DIRS})
endif()

if (Threads_FOUND)
    link_libraries(Threads::Threads)
endif()

if (NOT TBB_LIBRARY_PATH)
    set(SHARED_CPPS ${SHARED_CPPS} tinythread.cpp)
else()
    if (NOT NO_QUEUELOCK)
        add_definitions(-DWITH_TBB -DWITH_QUEUELOCK=1 -DNO_SPINLOCK)
    endif()
    include_directories(${TBB_INCLUDE_PATH})
    link_libraries(${TBB_LIBRARY_PATH} ${TBB_MALLOC_LIBRARY_PATH})
endif()

include_directories(${PROJECT_SOURCE_DIR})
get_directory_property(COMPILER_DEFS COMPILE_DEFINITIONS)
add_definitions(-DCOMPILER_OPTIONS="${CMAKE_CXX_FLAGS}")

add_executable(bowtie2-align-s ${SEARCH_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-align-l ${SEARCH_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-build-s ${BUILD_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-build-l ${BUILD_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-inspect-s ${INSPECT_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-inspect-l ${INSPECT_CPPS} ${SHARED_CPPS})

set_target_properties(bowtie2-align-l bowtie2-build-l bowtie2-inspect-l PROPERTIES COMPILE_FLAGS "-DBOWTIE2_64BIT_INDEX")
set_target_properties(bowtie2-inspect-s bowtie2-inspect-l PROPERTIES COMPILE_FLAGS "-DBOWTIE_INSPECT_MAIN")
set_target_properties(${BOWTIE2_BIN_LIST} PROPERTIES DEBUG_POSTFIX "-debug")

add_test(NAME simple-align COMMAND ${PROJECT_SOURCE_DIR}/bowtie2 -x example/index/lambda_virus example/reads/longreads.fq)

=== debian/changelog ===
bowtie2 (2.3.4.2-1) unstable; urgency=medium

  * New upstream version 2.3.4.2
  * Bump Standards-Version to 4.2.0
  * Refresh patches
  * Add patch fixing interpreter for bowite2 scripts
  * Add patch removing reference to js lib for ie...
  * Update uploader's email

 -- Alexandre Mestiashvili <mestia@debian.org>  Tue, 14 Aug 2018 13:31:56 +0200

bowtie2 (2.3.4.1-2) unstable; urgency=medium

  * Team upload.
  * Autopkgtest: add test that checks correct program behaviour when it called
    without arguments
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.4

 -- Liubov Chuprikova <chuprikovalv@gmail.com>  Tue, 12 Jun 2018 15:15:38 +0200

=== debian/control ===
Source: bowtie2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Alexandre Mestiashvili <mestia@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11),
               help2man,
               libtbb-dev,
               python,
               liblocal-lib-perl,
               libtest-deep-perl,
               libclone-perl,
               zlib1g-dev
Standards-Version: 4.2.0
Vcs-Browser: https://salsa.debian.org/med-team/bowtie2
Vcs-Git: https://salsa.debian.org/med-team/bowtie2.git
Homepage: http://bowtie-bio.sourceforge.net/bowtie2

Package: bowtie2
Architecture: amd64 kfreebsd-amd64
Depends: python,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: bowtie2-examples
Description: ultrafast memory-efficient short read aligner
 is an ultrafast and memory-efficient tool for aligning sequencing reads
 to long reference sequences. It is particularly good at aligning reads
 of about 50 up to 100s or 1,000s of characters, and particularly good
 at aligning to relatively long (e.g. mammalian) genomes.
 .
 Bowtie 2 indexes the genome with an FM Index to keep its memory footprint
 small: for the human genome, its memory footprint is typically
 around 3.2 GB. Bowtie 2 supports gapped, local, and paired-end alignment modes

Package: bowtie2-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: bowtie2
Enhances: bowtie2
Description: Examples for bowtie2
 An ultrafast and memory-efficient tool for aligning sequencing reads
 to long reference sequences. It is particularly good at aligning reads
 of about 50 up to 100s or 1,000s of characters, and particularly good
 at aligning to relatively long (e.g. mammalian) genomes.
 .
 Bowtie 2 indexes the genome with an FM Index to keep its memory footprint
 small: for the human genome, its memory footprint is typically
 around 3.2 GB. Bowtie 2 supports gapped, local, and paired-end alignment modes
 .
 This package provides some example data to work with bowtie2.

## bowtie2 2.3.4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 cmake_policy(SET CMP0048 NEW)
 cmake_policy(SET CMP0005 NEW)
 
-project(bowtie2 LANGUAGES CXX VERSION "2.3.4.2")
+project(bowtie2 LANGUAGES CXX VERSION "2.3.4.3")
 
 enable_testing()

=== Makefile ===
#
# Copyright 2011, Ben Langmead <langmea@cs.jhu.edu>
#
# This file is part of Bowtie 2.
#
# Bowtie 2 is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Bowtie 2 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Bowtie 2.  If not, see <http://www.gnu.org/licenses/>.
#

#
# Makefile for bowtie, bowtie2-build, bowtie2-inspect
#

prefix := /usr/local
bindir := $(prefix)/bin

LDLIBS := -lz
GCC_PREFIX := $(shell dirname `which gcc`)
GCC_SUFFIX :=
CC ?= $(GCC_PREFIX)/gcc$(GCC_SUFFIX)
CPP ?= $(GCC_PREFIX)/g++$(GCC_SUFFIX)
CXX ?= $(CPP)
CXXFLAGS += -std=c++98

HEADERS := $(wildcard *.h)
BOWTIE_MM := 1
BOWTIE_SHARED_MEM :=

ifdef STATIC_BUILD
	LDFLAGS += -L$(CURDIR)/.tmp/lib
	CPPFLAGS += -I$(CURDIR)/.tmp/include
endif

# Detect Cygwin or MinGW
WINDOWS :=
MINGW :=
ifneq (,$(findstring MINGW,$(shell uname)))
	WINDOWS := 1
	MINGW := 1
	# POSIX memory-mapped files not currently supported on Windows
	BOWTIE_MM :=
	BOWTIE_SHARED_MEM :=
endif

MACOS :=
ifneq (,$(findstring Darwin,$(shell uname)))
	MACOS := 1
	ifeq (1,$(shell uname -r | awk -F. '{ if ($$1 > 12 && $$1 < 16) print 1; }'))
		CXXFLAGS += -stdlib=libstdc++
	endif
	ifdef STATIC_BUILD
		CXXFLAGS += -mmacosx-version-min=10.9
	endif
endif

POPCNT_CAPABILITY ?= 1
ifeq (1, $(POPCNT_CAPABILITY))
    CXXFLAGS += -DPOPCNT_CAPABILITY
    CPPFLAGS += -I third_party
endif

MM_DEF :=

ifeq (1,$(BOWTIE_MM))
	MM_DEF := -DBOWTIE_MM
endif

SHMEM_DEF :=

ifdef BOWTIE_SHARED_MEM
	SHMEM_DEF := -DBOWTIE_SHARED_MEM
endif

PTHREAD_PKG :=
PTHREAD_LIB :=

#if we're not using TBB, then we can't use queuing locks
ifeq (1,$(NO_TBB))
	NO_QUEUELOCK := 1
endif

ifeq (1,$(MINGW))
	PTHREAD_LIB :=
else
	PTHREAD_LIB := -lpthread
endif

ifeq (1,$(NO_SPINLOCK))
	CXXFLAGS += -DNO_SPINLOCK
endif

#default is to use Intel TBB
ifneq (1,$(NO_TBB))
	LDLIBS += $(PTHREAD_LIB) -ltbb
	ifdef STATIC_BUILD
		LDLIBS += -ltbbmalloc
	else
		LDLIBS += -ltbbmalloc_proxy
	endif
	CXXFLAGS += -DWITH_TBB
else
	LDLIBS += $(PTHREAD_LIB)
endif

ifeq (1,$(WITH_THREAD_PROFILING))
	CXXFLAGS += -DPER_THREAD_TIMING=1
endif

ifeq (1,$(WITH_AFFINITY))
	CXXFLAGS += -DWITH_AFFINITY=1
endif

#default is to use Intel TBB's queuing lock for better thread scaling performance
ifneq (1,$(NO_QUEUELOCK))
	CXXFLAGS += -DNO_SPINLOCK
	CXXFLAGS += -DWITH_QUEUELOCK=1
endif

SHARED_CPPS := ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
               edit.cpp bt2_idx.cpp bt2_io.cpp bt2_util.cpp \
               reference.cpp ds.cpp multikey_qsort.cpp limit.cpp \
			   random_source.cpp

ifeq (1,$(NO_TBB))
	SHARED_CPPS += tinythread.cpp
endif

SEARCH_CPPS := qual.cpp pat.cpp sam.cpp \
               read_qseq.cpp aligner_seed_policy.cpp \
               aligner_seed.cpp \
			   aligner_seed2.cpp \
			   aligner_sw.cpp \
			   aligner_sw_driver.cpp aligner_cache.cpp \
			   aligner_result.cpp ref_coord.cpp mask.cpp \
			   pe.cpp aln_sink.cpp dp_framer.cpp \
			   scoring.cpp presets.cpp unique.cpp \
			   simple_func.cpp \
			   random_util.cpp \
			   aligner_bt.cpp sse_util.cpp \
			   aligner_swsse.cpp outq.cpp \
			   aligner_swsse_loc_i16.cpp \
			   aligner_swsse_ee_i16.cpp \
			   aligner_swsse_loc_u8.cpp \
			   aligner_swsse_ee_u8.cpp \
			   aligner_driver.cpp

SEARCH_CPPS_MAIN := $(SEARCH_CPPS) bowtie_main.cpp

DP_CPPS := qual.cpp aligner_sw.cpp aligner_result.cpp ref_coord.cpp mask.cpp \
          simple_func.cpp sse_util.cpp aligner_bt.cpp aligner_swsse.cpp \
		  aligner_swsse_loc_i16.cpp aligner_swsse_ee_i16.cpp \
		  aligner_swsse_loc_u8.cpp aligner_swsse_ee_u8.cpp scoring.cpp

BUILD_CPPS := diff_sample.cpp
BUILD_CPPS_MAIN := $(BUILD_CPPS) bowtie_build_main.cpp

SEARCH_FRAGMENTS := $(wildcard search_*_phase*.c)
VERSION := $(shell cat VERSION)

BITS := 32
ifeq (x86_64,$(shell uname -m))
	BITS := 64
endif
ifeq (amd64,$(shell uname -m))
	BITS := 64
endif
# msys will always be 32 bit so look at the cpu arch instead.
ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
	ifeq (1,$(MINGW))
		BITS := 64
	endif
endif
ifeq (32,$(BITS))
  $(error bowtie2 compilation requires a 64-bit platform )
endif

SSE_FLAG := -msse2

DEBUG_FLAGS    := -O0 -g3 -m64 $(SSE_FLAG)
RELEASE_FLAGS  := -O3 -m64 $(SSE_FLAG) -funroll-loops -g3
NOASSERT_FLAGS := -DNDEBUG
FILE_FLAGS     := -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(CXXFLAGS)\""
RELEASE_DEFS   = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(CXXFLAGS)\""

ifeq (0,$(shell $(CPP) -E -fsanitize=address,undefined btypes.h 2>&1 > /dev/null; echo $$?))
	SANITIZER_FLAGS := -fsanitize=address,undefined
endif
ifndef SANITIZER_FLAGS
	ifeq (0,$(shell $(CPP) -E -fsanitize=address btypes.h 2>&1 > /dev/null; echo $$?))
		SANITIZER_FLAGS := -fsanitize=address
	endif
endif
ifndef SANITIZER_FLAGS
	ifeq (0,$(shell $(CPP) -E -fsanitize=undefined btypes.h 2>&1 > /dev/null; echo $$?))
		SANITIZER_FLAGS := -fsanitize=undefined
	endif
endif

BOWTIE2_BIN_LIST :=     bowtie2-build-s \
                        bowtie2-build-l \
                        bowtie2-align-s \
                        bowtie2-align-l \
                        bowtie2-inspect-s \
                        bowtie2-inspect-l
BOWTIE2_BIN_LIST_DBG := bowtie2-build-s-debug \
                        bowtie2-build-l-debug \
                        bowtie2-align-s-debug \
                        bowtie2-align-l-debug \
                        bowtie2-inspect-s-debug \
                        bowtie2-inspect-l-debug
BOWTIE2_BIN_LIST_SAN := bowtie2-build-s-sanitized \
                        bowtie2-build-l-sanitized \
                        bowtie2-align-s-sanitized \
                        bowtie2-align-l-sanitized \
                        bowtie2-inspect-s-sanitized \
                        bowtie2-inspect-l-sanitized

GENERAL_LIST := $(wildcard scripts/*.sh) \
                $(wildcard scripts/*.pl) \
                doc/manual.html \
                doc/README \
                doc/style.css \
			    $(wildcard example/index/*.bt2) \
			    $(wildcard example/reads/*.fq) \
			    $(wildcard example/reads/*.pl) \
			    example/reference/lambda_virus.fa \
                $(PTHREAD_PKG) \
			    bowtie2 \
			    bowtie2-build \
			    bowtie2-inspect \
                AUTHORS \
                LICENSE \
                NEWS \
                MANUAL \
                MANUAL.markdown \
                TUTORIAL \
                VERSION

ifeq (1,$(WINDOWS))
	BOWTIE2_BIN_LIST := $(BOWTIE2_BIN_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
    ifneq (1,$(NO_TBB))
	    CXXFLAGS += -static-libgcc -static-libstdc++
	else
	    CXXFLAGS += -static -static-libgcc -static-libstdc++
	endif
endif

# This is helpful on Windows under MinGW/MSYS, where Make might go for
# the Windows FIND tool instead.
FIND := $(shell which find)

SRC_PKG_LIST = $(wildcard *.h) \
               $(wildcard *.hh) \
               $(wildcard *.c) \
               $(wildcard *.cpp) \
               $(wildcard third_party/*) \
               Makefile \
               $(GENERAL_LIST)

ifeq (1,$(WINDOWS))
	BIN_PKG_LIST := $(GENERAL_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
else
	BIN_PKG_LIST := $(GENERAL_LIST)
endif

.PHONY: all allall both both-debug

all: $(BOWTIE2_BIN_LIST) ;
allall: $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_DBG) $(BOWTIE2_BIN_LIST_SAN) ;
both: bowtie2-align-s bowtie2-build-s bowtie2-align-l bowtie2-build-l ;
both-debug: bowtie2-align-s-debug bowtie2-build-s-debug bowtie2-align-l-debug bowtie2-build-l-debug ;
both-sanitized: bowtie2-align-s-sanitized bowtie2-build-s-sanitized bowtie2-align-l-sanitized bowtie2-build-l-sanitized ;

DEFS := -fno-strict-aliasing \
        -DBOWTIE2_VERSION="\"`cat VERSION`\"" \
        -DBUILD_HOST="\"`hostname`\"" \
        -DBUILD_TIME="\"`date`\"" \
        -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
        $(FILE_FLAGS) \
        $(PREF_DEF) \
        $(MM_DEF) \
        $(SHMEM_DEF)

# set compiler flags for all sanitized builds
$(BOWTIE2_BIN_LIST_SAN): CXXFLAGS += $(SANITIZER_FLAGS)

#
# bowtie2-build targets
#

bowtie2-build-s-sanitized bowtie2-build-s: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-build-l-sanitized bowtie2-build-l: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-build-s-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-build-l-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

#
# bowtie2-align targets
#

bowtie2-align-s-sanitized bowtie2-align-s: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-align-l-sanitized bowtie2-align-l: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-align-s-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-align-l-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

#
# bowtie2-inspect targets
#

bowtie2-inspect-s-sanitized bowtie2-inspect-s: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
		$(CPPFLAGS) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-inspect-l-sanitized bowtie2-inspect-l: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN  -DBOWTIE_64BIT_INDEX -Wall \
		$(CPPFLAGS) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-inspect-s-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
		$(CPPFLAGS) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-inspect-l-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -DBOWTIE_INSPECT_MAIN -Wall \
		$(CPPFLAGS) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LDFLAGS) $(LDLIBS)

#
# bowtie2-dp targets
#

bowtie2-dp: bt2_dp.cpp $(HEADERS) $(SHARED_CPPS) $(DP_CPPS)

=== debian/changelog ===
bowtie2 (2.3.4.3-1) unstable; urgency=medium

  [ Steffen Möller ]
  * Updated OMICtools ref in d/u/metadata

  [ Alexandre Mestiashvili ]
  * New upstream version 2.3.4.3:
    - Fixed an issue causing `bowtie2-build` and `bowtie2-inspect`
      to output incomplete help text.
    - Fixed an issue causing `bowtie2-inspect` to crash.
    - Fixed an issue preventing `bowtie2` from processing paired and/or
      unpaired FASTQ reads together with interleaved FASTQ reads.
  * Bump Policy to 4.2.1

 -- Alexandre Mestiashvili <mestia@debian.org>  Tue, 25 Sep 2018 07:58:26 +0000

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                libtest-deep-perl,
                libclone-perl,
                zlib1g-dev
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/med-team/bowtie2
 Vcs-Git: https://salsa.debian.org/med-team/bowtie2.git
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2

## bowtie2 2.3.5.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

cmake_policy(SET CMP0048 NEW)
cmake_policy(SET CMP0005 NEW)

project(bowtie2 LANGUAGES CXX VERSION "2.3.5.1")

enable_testing()

include(CTest)
include(ExternalProject)
include(ProcessorCount)
include(CheckSymbolExists)

ProcessorCount(NUM_CORES)

option(BOWTIE_MM "enable bowtie2 memory mapping" ON)
option(BOWITE_SHARED_MM "enable shared memory mapping" ON)

set(CMAKE_CXX_STANDARD 98)
set(NO_TBB ${NO_TBB})
set(NO_SPINLOCK ${NO_SPINLOCK})
set(USE_SRA 0)
set(WITH_THREAD_PROFILING ${WITH_THREAD_PROFILING})
set(POPCNT_CAPABILITY ${POPCNT_CAPABILITY})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64 -g3 -Wall -msse2")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -funroll-loops")
set(INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE PATH "Installation directory for executables")

set(CMAKE_EXPORT_COMPILE_COMMANDS on)


if (MINGW)
  option(BOWTIE_MM "Memory mapped files not supported on Windows" OFF)
  option(BOWTIE_SHARED_MEM "Shared memory not supported on Windows" OFF)
endif(MINGW)

if (APPLE)
  set(CMAKE_XCODE_ATTRIBUTE_DEBUG_INFORMATION_FORMAT "dwarf-with-dsym")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
endif(APPLE)

set(BOWTIE2_BIN_LIST
  bowtie2-build-s
  bowtie2-build-l
  bowtie2-align-s
  bowtie2-align-l
  bowtie2-inspect-s
  bowtie2-inspect-l
  )

set(SHARED_CPPS
  ccnt_lut.cpp
  ref_read.cpp
  alphabet.cpp
  shmem.cpp
  edit.cpp
  bt2_idx.cpp
  bt2_io.cpp
  bt2_util.cpp
  reference.cpp
  ds.cpp
  multikey_qsort.cpp
  limit.cpp
  random_source.cpp
  )

set(SEARCH_CPPS
  qual.cpp pat.cpp sam.cpp
  read_qseq.cpp aligner_seed_policy.cpp
  aligner_seed.cpp
  aligner_seed2.cpp
  aligner_sw.cpp
  aligner_sw_driver.cpp aligner_cache.cpp
  aligner_result.cpp ref_coord.cpp mask.cpp
  pe.cpp aln_sink.cpp dp_framer.cpp
  scoring.cpp presets.cpp unique.cpp
  simple_func.cpp
  random_util.cpp
  aligner_bt.cpp sse_util.cpp
  aligner_swsse.cpp outq.cpp
  aligner_swsse_loc_i16.cpp
  aligner_swsse_ee_i16.cpp
  aligner_swsse_loc_u8.cpp
  aligner_swsse_ee_u8.cpp
  aligner_driver.cpp
  bowtie_main.cpp
  bt2_search.cpp
  )

set(BUILD_CPPS
  bt2_build.cpp
  diff_sample.cpp
  bowtie_build_main.cpp)

set(INSPECT_CPPS
  bt2_inspect.cpp
  )

string(TIMESTAMP BUILD_DATE)
execute_process(COMMAND ${CMAKE_CXX_COMPILER} -v OUTPUT_VARIABLE COMPILER_VERSION)

add_definitions(
  -DBOWTIE2
  -DBUILD_HOST="${CMAKE_HOST_SYSTEM}"
  -DBUILD_TIME="${BUILD_DATE}"
  -DCOMPILER_VERSION="${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_VERSION}"
  -DBOWTIE2_VERSION="${PROJECT_VERSION}"
  -D_LARGEFILE_SOURCE
  -D_FILE_OFFSET_BITS=64
  -D_GNU_SOURCE
  )

if (WITH_AFFINITY)
  add_definitions(-DWITH_AFFINITY=1)
endif()

if (NO_SPINLOCK)
  add_definitions(-DNO_SPINLOCK)
endif()

if (POPCNT_CAPABILITY)
  add_definitions(-DPOPCNT_CAPABILITY)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -I third_party")
endif()

if (USE_SRA)
  set(NGS_VER 2.9.2)
  set(NCBI_VDB_VER 2.9.2-1)

  find_package(Java COMPONENTS Development REQUIRED)
  find_package(PythonInterp REQUIRED)
  find_package(Perl REQUIRED)

  find_program(MAKE_EXE NAMES gmake nmake make)
  ExternalProject_add(ngs_project
    URL https://github.com/ncbi/ngs/archive/${NGS_VER}.tar.gz
    PREFIX ${CMAKE_CURRENT_BINARY_DIR}/ngs-${NGS_VER}
    BUILD_IN_SOURCE 1
    CONFIGURE_COMMAND ./configure --prefix=install
    BUILD_COMMAND ${MAKE_EXE}
    INSTALL_COMMAND ${MAKE_EXE} install
    )

  ExternalProject_Get_Property(ngs_project SOURCE_DIR)
  set(NGS_INSTALL_DIR ${SOURCE_DIR}/ngs-sdk/install)

  link_directories(${NGS_INSTALL_DIR}/lib64)
  include_directories(${NGS_INSTALL_DIR}/include)

  add_library(ngs-c++-static STATIC IMPORTED)
  add_dependencies(ngs-c++-static ngs_project)
  find_library(LIBNGS_CPP ngs-c++-static PATHS ${NGS_INSTALL_DIR}/lib64 NO_DEFAULT_PATH)
  set_property(TARGET ngs-c++-static PROPERTY IMPORTED_LOCATION ${LIBNGS_CPP})

  link_libraries(ngs-c++-static)

  ExternalProject_add(ncbi_vdb_project
    URL https://github.com/ncbi/ncbi-vdb/archive/${NCBI_VDB_VER}.tar.gz
    PREFIX ${CMAKE_CURRENT_BINARY_DIR}/ncbi-vdb-${NCBI_VDB_VER}
    BUILD_IN_SOURCE 1
    CONFIGURE_COMMAND ./configure --prefix=install --with-ngs-sdk=${NGS_INSTALL_DIR}
    BUILD_COMMAND ${MAKE_EXE}
    INSTALL_COMMAND ${MAKE_EXE} install
    DEPENDS ngs_project
    )

  ExternalProject_Get_Property(ncbi_vdb_project SOURCE_DIR)
  set(NCBI_VDB_INSTALL_DIR ${SOURCE_DIR}/install)

  link_directories(${NCBI_VDB_INSTALL_DIR}/lib64)
  include_directories(${NCBI_VDB_INSTALL_DIR}/include)

  add_library(ncbi-ngs-c++-static STATIC IMPORTED)
  add_dependencies(ncbi-ngs-c++-static ncbi_vdb_project)
  find_library(LIBNCBI_NGS_CPP ncbi-ngs-c++-static PATHS ${NCBI_VDB_INSTALL_DIR}/lib64 NO_DEFAULT_ATH)
  set_property(TARGET ncbi-ngs-c++-static PROPERTY IMPORTED_LOCATION ${LIBNCBI_NGS_CPP})

  add_library(ncbi-vdb-static STATIC IMPORTED)
  add_dependencies(ncbi-vdb-static ncbi_vdb_project)
  find_library(LIBNCBI_VDB ncbi-vdb-static PATHS ${NCBI_VDB_INSTALL_DIR}/lib64 NO_DEFAULT_PATH)
  set_property(TARGET ncbi-vdb-static PROPERTY IMPORTED_LOCATION ${LIBNCBI_VDB})

  link_libraries(ncbi-ngs-c++-static ncbi-vdb-static)
  add_definitions(-DUSE_SRA)
endif()

if (WITH_THREAD_PROFILING)
  add_definitions(-DPER_THREAD_TIMING=1)
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Release")
  add_definitions(-DNDEBUG)
endif()

find_package(ZLIB REQUIRED)


find_package(Threads REQUIRED)
link_libraries(Threads::Threads)

if (NO_TBB)
  set(SHARED_CPPS ${SHARED_CPPS} tinythread.cpp)
else()
  find_library(TBB_LIB_PATH tbb)

  if (TBB_LIB_PATH)
    find_path(TBB_INCLUDE_PATH tbb)
    link_libraries(${TBB_LIB_PATH})
    find_library(TBBMALLOC_PROXY_LIB_PATH tbbmalloc_proxy)
    if (NOT TBBMALLOC_PROXY_LIB_PATH)
      find_library(TBBMALLOC_LIB_PATH tbbmalloc)
      link_libraries(${TBBMALLOC_LIB_PATH})
    else()
      link_libraries(${TBBMALLOC_PROXY_LIB_PATH})
    endif()
    include_directories(${TBB_INCLUDE_PATH})
  else()
    set(TBB_VER 2019_U4)

    if (CMAKE_SYSTEM_NAME STREQUAL Linux)
      set(tbb_os linux)
    elseif (CMAKE_SYSTEM_NAME STREQUAL Darwin)
      set(tbb_os macos)
    elseif (CMAKE_SYSTEM_NAME STREQUAL Windows)
      set(tbb_os windows)
    else()
      set(tbb_os ${CMAKE_SYSTEM_NAME})
    endif()

    find_program(MAKE_EXE NAMES gmake nmake make)
    ExternalProject_Add(tbb_project
      URL https://github.com/01org/tbb/archive/2019_U4.tar.gz
      PREFIX ${CMAKE_CURRENT_BINARY_DIR}/tbb-${TBB_VER}
      BUILD_IN_SOURCE 1
      CONFIGURE_COMMAND ""
      BUILD_COMMAND ${MAKE_EXE} tbb_build_prefix=${TBB_VER} tbb_os=${tbb_os}
      INSTALL_COMMAND ""
      PREFIX=${CMAKE_CURRENT_BINARY_DIR}/tbb_project
      )

    ExternalProject_Get_Property(tbb_project SOURCE_DIR)

    set(TBB_SOURCE_DIR ${SOURCE_DIR})
    set(TBB_RELEASE_DIR ${TBB_SOURCE_DIR}/build/${TBB_VER}_release)
    include_directories(${TBB_SOURCE_DIR}/include)

    link_directories(${TBB_RELEASE_DIR})
    add_library(tbb SHARED IMPORTED)
    add_dependencies(tbb tbb_project)
    find_library(LIBTBB tbb PATHS ${TBB_RELEASE_DIR} NO_DEFAULT_PATH)
    set_property(TARGET tbb PROPERTY IMPORTED_LOCATION ${LIBTBB})

    add_library(tbbmalloc_proxy SHARED IMPORTED)
    add_dependencies(tbbmalloc_proxy tbb_project)
    find_library(LIBTBBMALLOC_PROXY tbbmalloc_proxy PATHS ${TBB_RELEASE_DIR} NO_DEFAULT_PATH)
    if (NOT LIBTBBMALLOC_PROXY)
      add_library(tbbmalloc SHARED IMPORTED)
      add_dependencies(tbbmalloc tbb_project)
      find_library(LIBTBBMALLOC tbbmalloc PATHS ${TBB_RELEASE_DIR} NO_DEFAULT_PATH)
      set_property(TARGET tbbmalloc PROPERTY IMPORTED_LOCATION ${LIBTBBMALLOC})
      link_libraries(tbb tbbmalloc)
    else()
      set_property(TARGET tbbmalloc_proxy PROPERTY IMPORTED_LOCATION ${LIBTBBMALLOC_PROXY})
      link_libraries(tbb tbbmalloc_proxy)
    endif()
  endif()
  add_definitions(-DWITH_TBB -DWITH_QUEUELOCK=1 -DNO_SPINLOCK)
endif()

if (ZLIB_FOUND)
  link_libraries(${ZLIB_LIBRARIES})
  include_directories(${ZLIB_INCLUDE_DIRS})
endif()

include_directories(${PROJECT_SOURCE_DIR})
get_directory_property(COMPILER_DEFS COMPILE_DEFINITIONS)
add_definitions(-DCOMPILER_OPTIONS="${CMAKE_CXX_FLAGS}")

add_executable(bowtie2-align-s ${SEARCH_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-align-l ${SEARCH_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-build-s ${BUILD_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-build-l ${BUILD_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-inspect-s ${INSPECT_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-inspect-l ${INSPECT_CPPS} ${SHARED_CPPS})

set_target_properties(bowtie2-align-l bowtie2-build-l bowtie2-inspect-l PROPERTIES COMPILE_FLAGS "-DBOWTIE2_64BIT_INDEX")
set_target_properties(bowtie2-inspect-s bowtie2-inspect-l PROPERTIES COMPILE_FLAGS "-DBOWTIE_INSPECT_MAIN")
set_target_properties(${BOWTIE2_BIN_LIST} PROPERTIES DEBUG_POSTFIX -debug)

add_test(NAME simple-align COMMAND ${PROJECT_SOURCE_DIR}/bowtie2 -x example/index/lambda_virus example/reads/longreads.fq)

=== Makefile ===
--- 
+++ 
@@ -31,15 +31,17 @@
 CPP ?= $(GCC_PREFIX)/g++$(GCC_SUFFIX)
 CXX ?= $(CPP)
 CXXFLAGS += -std=c++98
+ifeq (aarch64,$(shell uname -m))
+	CXXFLAGS += -fopenmp-simd
+	CPPFLAGS += -Ithird_party/simde
+endif
 
 HEADERS := $(wildcard *.h)
 BOWTIE_MM := 1
 BOWTIE_SHARED_MEM :=
 
-ifdef STATIC_BUILD
-	LDFLAGS += -L$(CURDIR)/.tmp/lib
-	CPPFLAGS += -I$(CURDIR)/.tmp/include
-endif
+NGS_VER ?= 2.9.2
+VDB_VER ?= 2.9.2-1
 
 # Detect Cygwin or MinGW
 WINDOWS :=
@@ -63,10 +65,15 @@
 	endif
 endif
 
+ifdef STATIC_BUILD
+	LDFLAGS += -L$(CURDIR)/.tmp/lib
+	CPPFLAGS += -I$(CURDIR)/.tmp/include
+endif
+
 POPCNT_CAPABILITY ?= 1
 ifeq (1, $(POPCNT_CAPABILITY))
-    CXXFLAGS += -DPOPCNT_CAPABILITY
-    CPPFLAGS += -I third_party
+	CXXFLAGS += -DPOPCNT_CAPABILITY
+	CPPFLAGS += -I third_party
 endif
 
 MM_DEF :=
@@ -104,12 +111,35 @@
 	LDLIBS += $(PTHREAD_LIB) -ltbb
 	ifdef STATIC_BUILD
 		LDLIBS += -ltbbmalloc
+	ifndef MINGW
+		LDLIBS += -ldl
+	endif
 	else
 		LDLIBS += -ltbbmalloc_proxy
 	endif
 	CXXFLAGS += -DWITH_TBB
 else
 	LDLIBS += $(PTHREAD_LIB)
+endif
+
+USE_SRA ?=
+ifeq (1, $(USE_SRA))
+ifdef MINGW
+	$(error "SRA binaries cannot be built on MINGW")
+else
+	LDFLAGS += -L$(CURDIR)/.tmp/lib64
+
+	ifndef ($(STATIC_BUILD))
+		CPPFLAGS += -I$(CURDIR)/.tmp/include
+	endif
+
+	LDLIBS += -lncbi-ngs-c++-static
+	LDLIBS += -lngs-c++-static
+	LDLIBS += -lncbi-vdb-static
+	LDLIBS += -ldl
+
+	CXXFLAGS += -DUSE_SRA
+endif
 endif
 
 ifeq (1,$(WITH_THREAD_PROFILING))
@@ -174,6 +204,9 @@
 ifeq (amd64,$(shell uname -m))
 	BITS := 64
 endif
+ifeq (aarch64,$(shell uname -m))
+	BITS := 64
+endif
 # msys will always be 32 bit so look at the cpu arch instead.
 ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
 	ifeq (1,$(MINGW))
@@ -185,9 +218,14 @@
 endif
 
 SSE_FLAG := -msse2
-
-DEBUG_FLAGS    := -O0 -g3 -m64 $(SSE_FLAG)
-RELEASE_FLAGS  := -O3 -m64 $(SSE_FLAG) -funroll-loops -g3
+M64_FLAG := -m64
+ifeq (aarch64,$(shell uname -m))
+	SSE_FLAG =
+	M64_FLAG =
+endif
+
+DEBUG_FLAGS    := -O0 -g3 $(M64_FLAG) $(SSE_FLAG)
+RELEASE_FLAGS  := -O3 $(M64_FLAG) $(SSE_FLAG) -funroll-loops -g3
 NOASSERT_FLAGS := -DNDEBUG
 FILE_FLAGS     := -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
 DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(CXXFLAGS)\""
@@ -230,20 +268,23 @@
                 $(wildcard scripts/*.pl) \
                 doc/manual.html \
                 doc/README \
+		Dockerfile-aarch64 \
                 doc/style.css \
-			    $(wildcard example/index/*.bt2) \
-			    $(wildcard example/reads/*.fq) \
-			    $(wildcard example/reads/*.pl) \
-			    example/reference/lambda_virus.fa \
+		$(wildcard example/index/*.bt2) \
+		$(wildcard example/reads/*.fq) \
+		$(wildcard example/reads/*.pl) \
+		example/reads/combined_reads.bam \
+		example/reference/lambda_virus.fa \
                 $(PTHREAD_PKG) \
-			    bowtie2 \
-			    bowtie2-build \
-			    bowtie2-inspect \
+		bowtie2 \
+		bowtie2-build \
+		bowtie2-inspect \
                 AUTHORS \
                 LICENSE \
                 NEWS \
                 MANUAL \
                 MANUAL.markdown \
+		README.md \
                 TUTORIAL \
                 VERSION
 
@@ -266,6 +307,7 @@
                $(wildcard *.cpp) \
                $(wildcard third_party/*) \
                Makefile \
+               CMakeLists.txt \
                $(GENERAL_LIST)
 
 ifeq (1,$(WINDOWS))
@@ -284,8 +326,8 @@
 
 DEFS := -fno-strict-aliasing \
         -DBOWTIE2_VERSION="\"`cat VERSION`\"" \
-        -DBUILD_HOST="\"`hostname`\"" \
-        -DBUILD_TIME="\"`date`\"" \
+        -DBUILD_HOST="\"${HOSTNAME:-`hostname`}\"" \
+        -DBUILD_TIME="\"`date -u -r NEWS`\"" \
         -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
         $(FILE_FLAGS) \
         $(PREF_DEF) \
@@ -385,32 +427,3 @@
 bowtie2-inspect-l-sanitized bowtie2-inspect-l: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
 	$(CXX) $(RELEASE_FLAGS) \
 		$(RELEASE_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN  -DBOWTIE_64BIT_INDEX -Wall \
-		$(CPPFLAGS) -I . \
-		-o $@ $< \
-		$(SHARED_CPPS) \
-		$(LDFLAGS) $(LDLIBS)
-
-bowtie2-inspect-s-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
-	$(CXX) $(DEBUG_FLAGS) \
-		$(DEBUG_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
-		$(CPPFLAGS) -I . \
-		-o $@ $< \
-		$(SHARED_CPPS) \
-		$(LDFLAGS) $(LDLIBS)
-
-bowtie2-inspect-l-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
-	$(CXX) $(DEBUG_FLAGS) \
-		$(DEBUG_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -DBOWTIE_INSPECT_MAIN -Wall \
-		$(CPPFLAGS) -I . \
-		-o $@ $< \
-		$(SHARED_CPPS) \
-		$(LDFLAGS) $(LDLIBS)
-
-#
-# bowtie2-dp targets
-#
-
-bowtie2-dp: bt2_dp.cpp $(HEADERS) $(SHARED_CPPS) $(DP_CPPS)

=== debian/changelog ===
bowtie2 (2.3.5.1-6build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:35:17 +0100

bowtie2 (2.3.5.1-6) unstable; urgency=medium

  * Team upload.
  * Remove the -m64 flag; not needed and not as universal as I thought
  * This means we build on arm64. (Closes: #925499)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 18 Dec 2019 13:36:56 +0100

bowtie2 (2.3.5.1-5) unstable; urgency=medium

  * Team upload.
  * debian/rules: Remove -santized here as well

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 18 Dec 2019 12:15:28 +0100

bowtie2 (2.3.5.1-4) unstable; urgency=medium

  * Team upload.
  * Added patch to correct the 64bit detection logic.
  * Disable -fsanitize builds to save resources

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 16 Dec 2019 10:13:27 +0100

bowtie2 (2.3.5.1-3) unstable; urgency=medium

  * Team upload.
  * Enable all architectures via simde.
  * Unset M64_FLAG and POPCNT_CAPABILITY on non AMD64 archs.
  * debian/rules: Fix testing in with cowdancer or eatmydata by unsetting
    LD_PRELOAD (the address sanitizer must be first in the library list)
  * Added missing ${perl:Depends} for the bowtie2 binary package

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 14 Dec 2019 13:42:14 +0100

bowtie2 (2.3.5.1-2) unstable; urgency=medium

  [ Steffen Möller ]
  * Added ref to conda

  [ Andreas Tille ]
  * SEQwiki is deprecated

  [ Steffen Moeller ]
  * d/u/metadata: yamllint

  [ Alexandre Mestiashvili ]
  * Update d/patches/2to3.patch, use importlib instead of deprecated imp module
    Closes: #945422
  * Add patch silencing TBB deprecation warnings
  * d/control: bump Policy to 4.4.1, add Rules-requires-root: no

 -- Alexandre Mestiashvili <mestia@debian.org>  Fri, 06 Dec 2019 22:38:21 +0100

bowtie2 (2.3.5.1-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * bowtie-examples: set Multi-Arch: foreign

  [ Steffen Moeller ]
  * debhelper-compat 12
  * Standards-Version: 4.4.0
  * New upstream version - yet fails to build -> crash

  [ Andreas Tille ]
  * Use 2to3 to port to Python3
    Closes: #936233
  * Remove obsolete fields Name, Contact from debian/upstream/metadata.
  * Build-Depends: libfile-which-perl
  * (Build-)Depends: s/python/python3/

 -- Alexandre Mestiashvili <mestia@debian.org>  Thu, 05 Sep 2019 15:45:04 +0200

=== debian/control ===
--- 
+++ 
@@ -4,24 +4,27 @@
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
                help2man,
                libtbb-dev,
-               python,
+               python3,
                liblocal-lib-perl,
                libtest-deep-perl,
                libclone-perl,
+               libfile-which-perl,
                zlib1g-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.4.1
+Rules-requires-root: no
 Vcs-Browser: https://salsa.debian.org/med-team/bowtie2
 Vcs-Git: https://salsa.debian.org/med-team/bowtie2.git
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2
 
 Package: bowtie2
-Architecture: amd64 kfreebsd-amd64
-Depends: python,
+Architecture: any
+Depends: python3,
          ${misc:Depends},
-         ${shlibs:Depends}
+         ${shlibs:Depends},
+         ${perl:Depends}
 Suggests: bowtie2-examples
 Description: ultrafast memory-efficient short read aligner
  is an ultrafast and memory-efficient tool for aligning sequencing reads
@@ -35,6 +38,7 @@
 
 Package: bowtie2-examples
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Recommends: bowtie2
 Enhances: bowtie2

=== debian/rules ===
#!/usr/bin/make -f

pkg := bowtie2

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
export LANG=C
export LC_ALL=C.UTF-8

include /usr/share/dpkg/architecture.mk
export DEB_CFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
export DEB_CXXFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3

EXTRA_OPTIONS =
ifneq ($(DEB_TARGET_ARCH),amd64)
        EXTRA_OPTIONS += NO_TBB=1 POPCNT_CAPABILITY=
else
        EXTRA_OPTIONS += POPCNT_CAPABILITY=1
endif

export EXTRA_OPTIONS

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS) \
	  bowtie2-build-s-debug \
	  bowtie2-build-l-debug \
	  bowtie2-align-s-debug \
	  bowtie2-align-l-debug \
	  bowtie2-inspect-s-debug \
	  bowtie2-inspect-l-debug
	make -j1 test
endif

override_dh_auto_install:
	dh_auto_install

override_dh_install:
	dh_install -X.gitignore

override_dh_installman:
	mkdir -p $(CURDIR)/debian/$(pkg)/usr/share/man/man1/
	debian/help2man-wrapper $(pkg) "wrapper for $(pkg)-align-*"
	debian/help2man-wrapper $(pkg)-build "wrapper for $(pkg)-build-*"
	debian/help2man-wrapper $(pkg)-build-l "building a colorspace index for $(pkg)"
	debian/help2man-wrapper $(pkg)-build-s "building a colorspace index for $(pkg)"
	debian/help2man-wrapper $(pkg)-inspect "wrapper for $(pkg)-inspect-* index"
	debian/help2man-wrapper $(pkg)-inspect-l "extracts information from a $(pkg) index"
	debian/help2man-wrapper $(pkg)-inspect-s "extracts information from a $(pkg) index"
	debian/help2man-wrapper $(pkg)-align-l "ultrafast and memory-efficient backend tool for aligning sequencing reads to long reference sequences"
	debian/help2man-wrapper $(pkg)-align-s "ultrafast and memory-efficient backend tool for aligning sequencing reads to long reference sequences"
	rm -f $(CURDIR)/debian/$(pkg)/usr/bin/bowtie2-buildc

override_dh_installchangelogs:
	dh_installchangelogs NEWS
